'From Smalltalk/X, Version:2.4.7 on 12-Jan-1993 at 21:32:36'!

Dictionary subclass:#CacheDictionary
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Collections-Unordered'
!

CacheDictionary comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

a CacheDictionary is a Dictionary which will not grow - i.e. keep
only a limited number of elements.

%W% %E%

written jan 93 by claus
'!

!CacheDictionary methodsFor:'private'!

findKeyOrNil:key  
    "Look for the key in the receiver.  If it is found, return
     the index of the association containing the key, otherwise
     return the index of the first unused slot. If no empty slot
     is available, make one empty"

    |index  "{ Class:SmallInteger }"
     length "{ Class:SmallInteger }"
     startIndex
     probe|

    length := keyArray basicSize.
    startIndex := key hash \\ length + 1.

    index := startIndex.
    [true] whileTrue:[
        probe := keyArray basicAt:index.
        (probe == nil or: [probe = key]) ifTrue:[^ index].

        index := index + 1.
        index > length ifTrue:[
            index := 1.
        ].
        index == startIndex ifTrue:[
            valueArray basicAt:startIndex put:nil.
            tally := tally - 1.
            ^ startIndex
        ].

    ]
! !
